#include <ode/ode.h>             
#include <drawstuff/drawstuff.h> 
#include <string>
#include <iostream> 

using namespace std;


class DSKoerperteil { 
public:
	DSKoerperteil(dWorldID welt, double xPos, double yPos, double zPos, double laenge){
		dMass masse;
		body=dBodyCreate(welt);
		dBodySetPosition(body, xPos, yPos, zPos);
		dMassSetZero(&masse);
		dMassSetCapsuleTotal(&masse, 0.17, 3 , 1.00, 0.20);
		dBodySetMass(body, &masse);
		this->laenge=laenge;
		this->welt=welt;
		offen=0;
	}
	void festSetzen() { //Damit die Arme nicht wild in der Gegend rumfliegen
		dJointID fest = dJointCreateFixed(welt, 0);
		dJointAttach(fest, body, 0);
		dJointSetFixed(fest);
	}

	void zeichneKoerperteil() {
		if(offen==0){
			dsDrawCapsule(dBodyGetPosition(body), 		dBodyGetRotation(body), laenge, 0.5);
		}
		else { //nur fuer Haende interresant
			float abstand=0.2; // es werden anstelle von einem Koerperteil, 3 Koerperteile gezeichnet, die nebeneinander stehen
			float pos1[3] = {dBodyGetPosition(body)[0]+abstand,dBodyGetPosition(body)[1],dBodyGetPosition(body)[2]};
			float pos2[3] = {dBodyGetPosition(body)[0],dBodyGetPosition(body)[1]+abstand,dBodyGetPosition(body)[2]};
			float pos3[3] = {dBodyGetPosition(body)[0],dBodyGetPosition(body)[1],dBodyGetPosition(body)[2]+abstand};

			dsDrawCapsule(pos1, 		dBodyGetRotation(body), laenge, 0.1);
			dsDrawCapsule(pos2, 		dBodyGetRotation(body), laenge, 0.1);
			dsDrawCapsule(pos3, 		dBodyGetRotation(body), laenge, 0.1);
		}
	}
	
	void oeffnen(){//nur fuer Haende interresant
		if(offen==0) {
			offen=1;
		}
	}
	void schliessen(){
		if(offen!=0) {
			offen=0;
		}
	}
	int getHand(){
		return offen; 
	}

	dBodyID getBody(){
		return body;
	}
private:
	
	dBodyID body;
	double laenge;
	dWorldID welt;
	int offen; //1=offen, 0 = geschlossen


};
