#include "DSKoerperteil.cpp"
#include <ode/ode.h>             
#include <drawstuff/drawstuff.h> 
#include <string>
#include <iostream> 

class ODEGelenk{
	public:
		ODEGelenk(DSKoerperteil *koerper1, DSKoerperteil *koerper2, dWorldID  welt, double anker1, double anker2, double anker3, double rot1, double rot2,double rot3) { //alle noetigen Werte werden hier uebergeben

	joint = dJointCreateHinge(welt, 0);
    dJointAttach(joint, koerper1->getBody(), koerper2->getBody()); //Die Koerperteile an ein Gelenk knuepfen
    dJointSetHingeAnchor(joint, anker1, anker2 ,anker3); //Den Ankerpunkt des Gelenk
    dJointSetHingeAxis(joint, rot1, rot2, rot3); //Die Rotationsachse festlegen 
	}

	void * getJoint() {
		return joint;
	}

	void setMinMax(double min, double max) { 
	//redundanterweise wird auch noch der joint jedes Gelenks beschraenkt
		dJointSetHingeParam(joint, dParamLoStop, min); 
		dJointSetHingeParam(joint, dParamHiStop, max);
		minWinkel=min;
		maxWinkel=max;
	}
	

	void bewege(){
		double k1 =  10.0,  fMax  = 100.0;
		double tmp = dJointGetHingeAngle(joint);
		double z =  aktuellerWinkel-tmp;
		dJointSetHingeParam(joint, dParamVel,k1*z);
	    	dJointSetHingeParam(joint, dParamFMax, fMax);			
		
	}
	void setWinkel(double winkel){
		if(minWinkel<=winkel&&winkel<=maxWinkel){
			
			aktuellerWinkel=winkel;
	
		}
		else { //falls die Begrenzung überschritten wurde, wird auf der Winkel das Maximum/Minimum gesetzt
			if(winkel<minWinkel){
				aktuellerWinkel=minWinkel;
			}
			if(winkel>maxWinkel){
				aktuellerWinkel=maxWinkel;
			}
		}
		
	}


	double getWinkel() {
		return aktuellerWinkel;
	}
	
	
	
		
	private:
		dJointID joint; //das ist die spezielle Implementierungsweise bei ODE
		double aktuellerWinkel; //in RAD
		double minWinkel;
		double maxWinkel;

};
